#include <stdio.h>
#include "funkce.h"

/* priklady na funkce */


/* vyhledani maxima v jednorozmernem poli typu double */
/* funkce vraci hodnotu maxima                        */

double maxa(double A[], int n)
{
 double MX;
 int    i;

 MX=A[0];
 for (i=1;i<n;i++)
   if (A[i]>MX) MX=A[i];
 return MX;
}


/* vyhledani maxima v jednorozmernem poli typu double */
/* funkce vraci pozici maxima                         */

int maxb(double A[], int n)
{
 int i,poz;

 poz=0;
 for (i=1;i<n;i++)
   if (A[i]>A[poz]) poz=i;
 return poz;
}

/* vyhledani maxima v jednorozmernem poli typu double */
/* funkce pointer na max prvek                        */

double *maxc(double *A, int n)
{
 double *p1, *p2;

 p2=A;
 for (p1=A+1;p1<A+n;p1++)
   if (*p1>*p2) p2=p1;
 return p2;
}


/* vyhledani 2.maxima v jednorozmernem poli typu double */
/* funkce vraci hodnotu 2.maxima                        */

double maxa2(double A[], int n)
{
 double MX1,MX2;
 int    i;

 MX1=-1E300; MX2=MX1;
 for (i=0;i<n;i++) {
   if (A[i]>MX1) {
     MX2=MX1;
     MX1=A[i];
     }
   else
     {
     if ((A[i]>MX2)&&(A[i]<MX1)) MX2=A[i];
     }
 }
 return MX2;
}
