#include <stdio.h>

/* Priklad na dvojrozmerne dynamicke pole s pevnym poctem sloupcu a dynamickym 
   poctem radku
*/
   

typedef double BOD[2];


char jmenoI[]="LINF.DAT";
char jmenoO[]="LINF.TXT";


int poc_bod()
{
 FILE *fr;
 double X;
 int i;

 int n=0;

 fr=fopen(jmenoI, "r");
 if (fr==NULL) return 0;
 while (!feof(fr))
  {
   i=fscanf(fr, "%lf", &X);
   if (i==1)
     n++;
    else
     break;
  }
 fclose(fr);
 return n/2;
}

int nacti_f(BOD *fce)
{
 FILE *fr;
 int n=0;
 int i;
 double X,Y;

 fr=fopen(jmenoI, "r");
 if (fr==NULL) return 0;
 while (!feof(fr))
  {
   i=fscanf(fr, "%lf %lf", &X, &Y);
   if (i==2)
     {
      fce[n][0]=X;
      fce[n][1]=Y;
      n++;
      }
    else
     break;
  }
 fclose(fr);
 return n;
}

double hod_f(double X, int n, BOD *fce)
{
 int i;
 double Y;

 i=0;
 while ((i<n-1)&&(X>fce[i][0]))
  i++;
 if (i>0) i--;
 Y=fce[i][1]+(X-fce[i][0])*(fce[i+1][1]-fce[i][1])/(fce[i+1][0]-fce[i][0]);
 return Y;

}


int main()
{
 FILE *fw;

 int i,n;
 BOD *FX;
 double X, Y;

 n=poc_bod();
 if (n<2)
   {
    printf("\nChybna funkce\n");
    return 1;
   }

 FX=(BOD *)malloc(n*sizeof(BOD));
 n=nacti_f(FX);

 fw=fopen(jmenoO, "w");
 for (i=-50;i<=50;i++)
  {
   X=0.1*i;
   Y=hod_f(X, n, FX);
   fprintf(fw, "%10.3f %10.3f\n", X, Y);
  }

 fclose(fw);
 printf("\nOK.");
 return 0;
}
