#include <stdio.h>

/* priklad na datovou strukturu LIFO vazanym seznamem */


typedef struct LIFOS {
	 int pol;
	 struct LIFOS *prev;
	 } lifos;


/* globalni promenna - ukazatel na seznam */
lifos *lifo=NULL;


void vloz(int X)
{
 lifos *pom;
 pom=(lifos *)malloc(sizeof(lifos));
 pom->pol=X;
 pom->prev=lifo;
 lifo=pom;
}

int vyber()
{
 lifos *pom;
 int i;
 if (lifo==NULL) {
  printf("Vybirani neplatnych dat");
  exit(0);
  }
 i=lifo->pol;
 pom=lifo->prev;
 free(lifo);
 lifo=pom;
 return i;
}

int main()
{int i,cislo;
 vloz(3);vloz(100);vloz(-5);
 for (i=0;i<3;i++) printf("\n%d", vyber());
 cislo=100;
 while (cislo)
   {
    vloz(cislo%2);
    cislo=cislo/2;
   }
 puts("\nCislo 100 binarne:");
 while (lifo!=NULL)
  {
   printf("%d", vyber());
  }
 getchar();
 return 0;
}
 