#include <stdio.h>
#include <stdlib.h>

/* Priklad na vazany seznam. Funkce pro pridani na zacatek,
   zjisteni poctu polozek a vypis sudych cisel */


typedef struct POL
  { int data;
    struct POL *next;
  } pol;

pol *zac=NULL;

int pridej(int x)
{
 pol *pom;
 pom=(pol *)malloc(sizeof(pol));
 if (pom==NULL) {
   printf("\nNedostatek pameti");
   return 1;
   }
 pom->data=x;
 pom->next=zac;
 zac=pom;
 return 0;
}



int pocpol()
{
 int n=0;
 pol *pom;
 pom=zac;
 while (pom!=NULL) {
  n++;
  pom=pom->next;
  }
 return n;
}

void vypissude()
{
 pol *pom;
 printf("\nSuda cisla: ");
 pom=zac;
 while (pom!=NULL) {
  if ((pom->data % 2)==0) printf(" %d", pom->data);
  pom=pom->next;
  }
}

void main()
{
 int i;
 int err=0;
 printf("Zadavejte cela cisla. Ukonceni zadanim nuly.\n");
 while (err==0) {
   printf(": ");
   scanf("%d", &i);
   if (i!=0) {
     err=pridej(i);
     }
   else err=-1;
 }
 printf("\nCelkem bylo zadano %d cisel.", pocpol());
 vypissude();
}
