#include <stdio.h>
#include <stdlib.h>

/* Priklad na vazany seznam. Funkce pro pridani doprostred,
   nalezeni nejblizsiho nizsiho cisla, zjisteni poctu polozek,
   vypis vsech cisel. Radi vzestupne pri vkladani. */



typedef struct POL
  { int data;
    struct POL *next;
  } pol;

pol *zac=NULL;

pol *mensi(int q)
{
pol *pom,*x;
if (zac==NULL) return NULL;
pom=zac;
x=NULL;
while ((pom!=NULL) && (pom->data<q)) {
  x=pom;
  pom=pom->next;
  }
return x;
}

int pridej3(int x)
{
 pol *pom,*pos;
 pom=(pol *)malloc(sizeof(pol));
 if (pom==NULL) {
   printf("\nNedostatek pameti");
   return 1;
   }
 pom->data=x;
 pos=mensi(x);
 if (pos==NULL)
   {
    pom->next=zac;
    zac=pom;
   }
 else
  {
   pom->next=pos->next;
   pos->next=pom;
  }
 return 0;
}

int pocpol()
{
 int n=0;
 pol *pom;
 pom=zac;
 while (pom!=NULL) {
  n++;
  pom=pom->next;
  }
 return n;
}

void vypisvse()
{
 pol *pom;
 printf("\nZadana cisla: ");
 pom=zac;
 while (pom!=NULL) {
  printf(" %d", pom->data);
  pom=pom->next;
  }
}

void main()
{
 int i;
 int err=0;
 printf("Zadavejte cela cisla. Ukonceni zadanim nuly.\n");
 while (err==0) {
   printf(": ");
   scanf("%d", &i);
   if (i!=0) {
     err=pridej3(i);
     }
   else err=-1;
 }
 printf("\nCelkem bylo zadano %d cisel.", pocpol());
 vypisvse();
}
